poj 3735 Training little cats

点击打开poj 3735

思路: 矩阵快速幂

分析:

1 题目给定n只猫,每只猫的初始的花生的数量为0。现在有三种操作,g i 第i只猫加一个花生,e i 把第i只猫的所有花生全部吃完 s i j 把第i 和 j只猫的花生数进行交换

2 根据上面的三种操作那么我们能够举例n = 3的时候的三种操作。

   对于g 1,我们把第一行的最后一位加1,这里增加了一列目的是为了能够求出和,因为初始化a b c都为0 

   1 0 0 1       a        a+1

   0 1 0 0   *  b   =   b

   0 0 1 0       c         c

   0 0 0 1       1         1

   对于e 1,我们把第一行全部置为0,那么这样就是相当于吃掉全部的花生

   0 0 0 0       a        0

   0 1 0 0   *  b   =   b

   0 0 1 0       c         c

   0 0 0 1       1         1

   对于 s 1 2 

   0 1 0 0       a        b

   1 0 0 0   *  b   =   a

   0 0 1 0       c         c

   0 0 0 1       1         1

3 那么我们只要先把k次的操作整合到一个矩阵A里面,然后求A^m,矩阵的最后一列的前n个数即为所求

4 由于矩阵乘法涉及到乘的次数越多,就越耗时间,因此我们需要在矩阵相乘的时候进行优化

代码:

/************************************************
 * By: chenguolin                               *
 * Date: 2013-08-31                             *
 * Address: http://blog.csdn.net/chenguolinblog *
 ************************************************/
#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>
using namespace std;

typedef long long int64;
const int N = 105;

int n , m , k;
struct Matrix{
    int64 mat[N][N];
    Matrix operator*(const Matrix& ma)const{
        Matrix tmp;
        for(int i = 0 ; i <= n ; i++){
            for(int j = 0 ; j <= n ; j++){
                tmp.mat[i][j] = 0;
                for(int k = 0 ; k <= n ; k++){
                    if(mat[i][k] && ma.mat[k][j])
                       tmp.mat[i][j] += mat[i][k]*ma.mat[k][j];
                }
            }
        }
        return tmp;
    }
};

void input(Matrix &ma){
    char c;
    int x , y;
    memset(ma.mat , 0 , sizeof(ma.mat));
    for(int i = 0 ; i <= n ; i++)
        ma.mat[i][i] = 1;
    while(k--){
         scanf("%c" , &c);
         if(c == 'g'){
             scanf("%d%*c" , &x);
             x--;
             ma.mat[x][n]++;
         }
         else if(c == 's'){
             scanf("%d%d%*c" , &x , &y);
             x-- , y--;
             for(int i = 0 ; i <= n ; i++){
                 int tmp = ma.mat[x][i];
                 ma.mat[x][i] = ma.mat[y][i];
                 ma.mat[y][i] = tmp;
             }
         }
         else{
             scanf("%d%*c" , &x);
             x--;
             for(int i = 0 ; i <= n ; i++)
                 ma.mat[x][i] = 0;
         }
    }
}

void Pow(Matrix &ma){
    Matrix ans;
    memset(ans.mat , 0 , sizeof(ans.mat));
    for(int i = 0 ; i <= n ; i++)
        ans.mat[i][i] = 1;
    while(m){
        if(m&1)
            ans = ans*ma;
        m >>= 1;
        ma = ma*ma;
    }
    for(int i = 0 ; i < n ; i++){
        if(i) printf(" ");
        printf("%lld" , ans.mat[i][n]);
    }
    puts("");
}

int main(){
    Matrix ma;
    while(scanf("%d%d%d%*c" , &n , &m , &k) && n+m+k){
        input(ma);
        Pow(ma);
    }
    return 0;
}
时间: 2024-11-09 00:08:19

poj 3735 Training little cats的相关文章

矩阵快速幂专题【完结】

第一题 hdu 1757 A Simple Math Problem 点击打开链接 思路:矩阵快速幂 分析: 1 最简单的矩阵快速幂的题目,直接利用矩阵求解即可 点击打开查看代码 第二题 hdu 1575 Tr A 点击打开hdu 1575 思路: 矩阵快速幂 分析: 1 题目给定一个n*n的矩阵要求矩阵的k次幂之后的矩阵的对角线的和 2 矩阵快速幂的裸题 点击打开查看代码 第三题 hdu 2604 Queuing 点击打开hdu 2604 思路: 递推+矩阵快速幂 分析; 1 根据题目的意思,

HDU 2818 Building Block, poj 1988 Cube Stacking:带权并查集

链接: HDU: http://acm.hdu.edu.cn/showproblem.php?pid=2818 POJ:  http://poj.org/problem?id=1988 题目: Problem Description John are playing with blocks. There are N blocks (1 <= N <= 30000) numbered 1...N.Initially, there are N piles, and each pile contai

POJ题目分类

初期: 一.基本算法:      (1)枚举. (poj1753,poj2965)      (2)贪心(poj1328,poj2109,poj2586)      (3)递归和分治法.      (4)递推.      (5)构造法.(poj3295)      (6)模拟法.(poj1068,poj2632,poj1573,poj2993,poj2996) 二.图算法:      (1)图的深度优先遍历和广度优先遍历.      (2)最短路径算法(dijkstra,bellman-ford

POJ:DNA Sorting 特殊的排序

Description One measure of ``unsortedness'' in a sequence is the number of pairs of entries that are out of order with respect to each other. For instance, in the letter sequence ``DAABEC'', this measure is 5, since D is greater than four letters to

POJ 1001 Exponentiation 无限大数的指数乘法 题解

POJ做的很好,本题就是要求一个无限位大的指数乘法结果. 要求基础:无限大数位相乘 额外要求:处理特殊情况的能力 -- 关键是考这个能力了. 所以本题的用例特别重要,再聪明的人也会疏忽某些用例的. 本题对程序健壮性的考查到达了变态级别了. 更多精彩内容:http://www.bianceng.cnhttp://www.bianceng.cn/Programming/sjjg/ 某人贴出的测试用例数据地址: http://poj.org/showmessage?message_id=76017 有

POJ 2240 Arbitrage:最短路 Floyd

Arbitrage:http://poj.org/problem?id=2240 大意: 给你m种货币,给你m种货币兑换规则,问通过这些规则最后能不能盈利.eg:1美元换0.5英镑,1英镑换10法郎,1法郎换0.21美元,这样1美元能换0.5*10*0.21=1.05美元,净赚0.05美元. 思路: 用Floyd找出每两种钱之间的最大兑换关系,遍历一遍,看有没有那种钱币最后能盈利,有就输出Yes,没有就是No.在处理钱币名称与编号之间的关系时,可以用map存(比较好用),当然也可以用字符串比较.

POJ 1860 Currency Exchange:最短路 Bellman-Ford

Currency Exchange:http://poj.org/problem?id=1860 大意:有多种货币,之间可以交换,但是需要手续费,也就是说既有汇率又有手续费.问经过交换之后能不能赚. 思路:Bellman_Ford,因为要求最长路,所以松弛条件改一下就好了. Tips: 3              2                  1                20.0货币的数量   兑换点的数量     主人公拥有的货币量    主人公拥有货币的价值1 2 1.00

POJ 1258 Agri-Net:最小生成树 Prim 模版题

Agri-Net:http://poj.org/problem?id=1258 大意:新镇长竞选宣言就是将网络带到每一个农场,给出农场个数,两两之间建光缆的耗费,求所有都联通的最小耗费. 思路:最小生成树,因为边比较稠密,用Prim做. PS:对于比较稠密的图,用Prim,对于比较稀疏的图,用 Kruskal.Kruskal是找边的过程,稀疏的话会比较快. 更多精彩内容:http://www.bianceng.cnhttp://www.bianceng.cn/Programming/sjjg/

POJ 1789 Truck History:最小生成树 Prim

Truck History:http://poj.org/problem?id=1789 大意:用一个7位的string代表一个编号,两个编号之间的距离代表这两个编号之间不同字母的个数.一个编号只能由另一个编号变化的来,变化的字母的数量就是这两个编号之间相应的距离,现在要找出一个变化方案,使得总代价最小,也就是距离之和最小. 思路:将每个字符串当成一个节点,求出每个节点之间需要变化的次数为边的权值,用Prim建立最小生成树(稠密图). 更多精彩内容:http://www.bianceng.cnh